/*
 * ^NgXCb`Cu Version 1.00
 * File:        sw.c
 * Target:      PIC18F14K50 48Mhz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/09/29 15:00
*/

#include <p18f14k50.h>
#include <plib\delays.h>
#include "sw.h" //  XCb`̃AhXErbg`

static unsigned char sw_2before=SW_MASK,sw_before,sw_last,sw_trg;

//  XCb`̏Ԃ擾(`^O) 0: 1:

unsigned char sw_in(void){
    for(;;){
        sw_before=SW_ADS & SW_MASK;
        Delay1KTCYx( 120);  //  10ms*(48MHz/4)= 120,000
        sw_last=SW_ADS & SW_MASK;
        if((sw_before ^ sw_last)==0) // OƕωȂꍇ`^O͂Ȃ
            break;
        sw_before=sw_last;
        Delay1KTCYx( 120);  //  10ms*(48MHz/4)= 120,000
    }
    return sw_last;
}

//  XCb`̏Ԃƕω擾(`^O)  0: 1: 0:ωȂ 1:ω

void sw_trg_in(unsigned char* sw,unsigned char* trg){
    unsigned char sw2;
    sw_in();
    sw_trg=sw_last ^ sw_2before;
    sw2=sw_2before;
    sw_2before=sw_last;
    *sw=sw_last;
    *trg=sw_trg;
}

//  gp

/*
void sw_info(char* buf,unsigned char sw,unsigned char trg,unsigned char mask){
    if((sw & mask)==0){
        if(trg & mask)
            strcpy(buf,"Off->On");
        else
            strcpy(buf,"On     ");
    }else{
        if(trg & mask)
            strcpy(buf,"On->Off");
        else
            strcpy(buf,"Off    ");
    }
}

*/